; Demo 1
(define (nats start) 
	(cons-stream start (nats (+ start 1))))

;scm> (nats 1)
;(1 . #[promise (not forced)])
;scm> (car (nats 1))
;1
;scm> (cdr (nats 1))
;#[promise (not forced)]
;scm> (cdr-stream (nats 1))
;(2 . #[promise (not forced)])
;scm> (cdr-stream (cdr-stream (nats 1)))
;(3 . #[promise (not forced)])


; Demo 2
(define (add-stream s1 s2)
	(cons-stream (+ (car s1) (car s2)) 
		(add-stream (cdr-stream s1) (cdr-stream s2))))

(define ones (cons-stream 1 ones))

(define ints (cons-stream 1 (add-stream ones ints)))

;scm> ints
;(1 . #[promise (not forced)])
;scm> (cdr-stream ints)
;(2 . #[promise (not forced)])
;scm> (cdr-stream (cdr-stream ints))
;(3 . #[promise (not forced)])
;scm> (cdr-stream (cdr-stream (cdr-stream ints)))
;(4 . #[promise (not forced)])

; Demo 3
(define (map-stream fn s)
	(if (null? s)
	    nil
	    (cons (fn (car s))
			 (map-stream fn (cdr-stream s))))) 


;scm> (nats 1)
;(1 . #[promise (not forced)])
;scm> (map-stream (lambda (x) (* x x)) (nats 1))
;(1 . #[promise (not forced)])
;scm> (cdr-stream (map-stream (lambda (x) (* x x)) (nats 1)))
;(4 . #[promise (not forced)])
;scm> (cdr-stream (cdr-stream (map-stream (lambda (x) (* x x)) (nats 1))))
;(9 . #[promise (not forced)])

; Demo 4
(define (stream-to-list s num-elements)
	(if (or (null? s) (= 0 num-elements))
	    nil
	    (cons (car s) (stream-to-list (cdr-stream s) (- num-elements 1)))))	

; (stream-to-list (nats 1) 6)
; (stream-to-list nil 6)
; (stream-to-list (nats 10) 9)

